package net.nigreon.blegps

import android.content.Context
import android.location.Location
import android.location.LocationManager
import android.os.SystemClock
import android.util.Log

class MockLocationProvider(val providerName: String, val ctx: Context) {

    private val LOG_TAG = "MockLocationProvider"

    private val lm = ctx.getSystemService(
        Context.LOCATION_SERVICE
    ) as LocationManager

    fun start() {
       try {
           lm.removeTestProvider(providerName)
       } catch(exception: Exception) {
           Log.w(LOG_TAG,"No TestProvider to remove")
       }
       /* if(providerName in lm.getAllProviders()) {
            lm.removeTestProvider(providerName)
        }*/
        //try {
            lm.addTestProvider(
                providerName, false, false, false, false, true,
                true, true, 0, 5
            )
        /*} catch() {
            lm.removeTestProvider(providerName)
            lm.addTestProvider(
                providerName, false, false, false, false, true,
                true, true, 0, 5
            )
        }*/
        lm.setTestProviderEnabled(providerName, true)
    }

    fun pushLocation(lat: Double, lon: Double, alt: Double, speed: Float, heading: Float, accuracy: Float) {
        val mockLocation = Location(providerName)
        mockLocation.latitude = lat
        mockLocation.longitude = lon
        mockLocation.altitude = alt
        mockLocation.speed = speed
        mockLocation.bearing = heading
        mockLocation.time = System.currentTimeMillis()
        mockLocation.accuracy = accuracy
        mockLocation.elapsedRealtimeNanos = SystemClock.elapsedRealtimeNanos()

        lm.setTestProviderLocation(providerName, mockLocation)
    }

    fun shutdown() {
        lm.removeTestProvider(providerName)
    }
}